require_relative 'mm_metrics/backends/dd'
require_relative 'mm_metrics/loggers';
require_relative 'mm_metrics/config';

def get_metrics_backend(opts={})
	log_level = Settings::DEBUG ? :debug : :warn

	logger = StreamLogger.new(log_level).log

	DataDogMetricsBackend.new(**opts, logger: logger)
end

# runs a timer around a block
def timer(metric, tags: [])
	metrics = get_metrics_backend

	start = Process.clock_gettime(Process::CLOCK_MONOTONIC) 

	return yield
ensure
	finished = Process.clock_gettime(Process::CLOCK_MONOTONIC)

	metrics.timed(metric, ((finished - start) * 1000).round, tags: tags)
end
